Bug 1646381 - glibc: Crash in getaddrinfo_a when thread creation fails
Summary: glibc: Crash in getaddrinfo_a when thread creation fails
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: glibc
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Florian Weimer
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1646373 1646379
TreeView+ depends on / blocked
 
Reported: 2018-11-05 13:39 UTC by Florian Weimer
Modified: 2019-05-28 23:24 UTC (History)
10 users (show)

Fixed In Version: glibc-2.28-18.fc29 glibc-2.28.9000-14.fc30 glibc-2.26-32.fc27 glibc-2.27-35.fc28
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1646373
Environment:
Last Closed: 2019-05-28 23:24:56 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Sourceware 22927 None None None 2019-06-26 15:29:51 UTC

Description Florian Weimer 2018-11-05 13:39:46 UTC
+++ This bug was initially created as a clone of Bug #1646373 +++

From the upstream bug report:

At line 237 in gai_misc.c:

lastp = requests_tail;
if (requests_tail == NULL)
  requests = requests_tail = newp;
else ...

If requests_tail was NULL then lastp remains NULL. 
Unfortunately if gai_create_helper_thread fails, lastp is de-referenced at line 267 which will cause a SIGSEGV.

--- Additional comment from Florian Weimer on 2018-11-05 14:30:00 CET ---

This should be reproducible with a custom malloc which fails after the right number of allocations.

Comment 1 Florian Weimer 2018-11-05 13:54:20 UTC
Upstream commit:

commit bd3b0fbae33a9a4cc5e2daf049443d5cf03d4251
Author: Andreas Schwab <schwab@suse.de>
Date:   Mon Nov 5 12:47:30 2018 +0100

    libanl: properly cleanup if first helper thread creation failed (bug 22927)

Comment 2 Fedora Update System 2018-11-19 16:48:26 UTC
glibc-2.28-20.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-6945150e0d

Comment 3 Fedora Update System 2018-11-19 16:48:29 UTC
glibc-2.28-20.fc29 has been submitted as an update to Fedora 29. https://bodhi.fedoraproject.org/updates/FEDORA-2018-6945150e0d

Comment 4 Fedora Update System 2018-11-20 17:02:44 UTC
glibc-2.28-20.fc29 has been pushed to the Fedora 29 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-6945150e0d

Comment 5 Fedora Update System 2018-11-22 03:20:58 UTC
glibc-2.28-20.fc29 has been pushed to the Fedora 29 stable repository. If problems still persist, please make note of it in this bug report.

Comment 6 Ben Cotton 2018-11-27 13:31:00 UTC
This message is a reminder that Fedora 27 is nearing its end of life.
On 2018-Nov-30  Fedora will stop maintaining and issuing updates for
Fedora 27. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora  'version' of '27'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 27 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 7 Fedora Update System 2018-11-28 08:58:35 UTC
glibc-2.26-32.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2018-f27586cce9

Comment 8 Fedora Update System 2018-11-28 13:31:57 UTC
glibc-2.27-35.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-060302dc83

Comment 9 Fedora Update System 2018-11-29 02:03:19 UTC
glibc-2.27-35.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-060302dc83

Comment 10 Fedora Update System 2018-11-29 03:05:27 UTC
glibc-2.26-32.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-f27586cce9

Comment 11 Fedora Update System 2018-12-04 02:23:08 UTC
glibc-2.27-35.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.

Comment 12 Ben Cotton 2019-05-02 20:10:58 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 13 Ben Cotton 2019-05-28 23:24:56 UTC
Fedora 28 changed to end-of-life (EOL) status on 2019-05-28. Fedora 28 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.